<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" integrity="sha512-iBBXm8fW90+nuLcSKlbmrPcLa0OT92xO1BIsZ+ywDWZCvqsWgccV3gFoRBv0z+8dLJgyAHIhR35VZc2oM/gI1w==" crossorigin="anonymous" referrerpolicy="no-referrer" />

<div class="container py-5" id="app">
  <div class="row">
    <div class="col">
      <textarea v-model="text" @input="diegest" style="width: 500px; height: 500px !important;"></textarea>
    </div>

    <div class="col mt-5">
      <table class="table table-striped table-hover">
        <thead>
          <th colspan="3">Data</th>
        </thead>
        <tbody>
          <tr>
            <th scope="row">payment </th>
            <td colspan="2">{{ payment }}</td>
          </tr>
          <tr @click="copy2c($event)">
            <th scope="row">payment amount </th>
            <td id="data">{{ payment_amount }}</td>
            <td>
              <button type="button" class="btn btn-dark btn-sm float-end" @click="copy2c($event)"><i class="fas fa-clipboard"></i></button>
            </td>
          </tr>
          <tr @click="copy2c($event)">
            <th scope="row">payment method </th>
            <td id="data">{{ payment_method }}</td>
            <td>
              <button type="button" class="btn btn-dark btn-sm float-end" @click="copy2c($event)"><i class="fas fa-clipboard"></i></button>
            </td>
          </tr>
          <tr v-if="comp_amount" @click="copy2c($event)">
            <th scope="row">company parts </th>
            <td id="data">{{ comp_amount }}</td>
            <td>
              <button type="button" class="btn btn-dark btn-sm float-end" @click="copy2c($event)"><i class="fas fa-clipboard"></i></button>
            </td>
          </tr>
          <tr @click="copy2c($event)">
            <th scope="row">zip </th>
            <td id="data">{{ zipcode }}</td>
            <td>
              <button type="button" class="btn btn-dark btn-sm float-end" @click="copy2c($event)"><i class="fas fa-clipboard"></i></button>
            </td>
          </tr>
        </tbody>
      </table>
      Click on row to copy value.

      <!-- <div class="col"></div> -->
      <!-- <div class="row">payment amount: </div>
      <div class="col">{{ payment_amount }} <button type="button" class="btn btn-dark float-end" @click="copy2c(1)"><i class="fas fa-clipboard"></i></button> </div>
      <div class="row">payment method: </div>
      <div class="col">{{ payment_method }} <button type="button" class="btn btn-dark float-end" @click="copy2c(2)"><i class="fas fa-clipboard"></i></button> </div>

      <div class="row" v-if="comp_amount"> company parts: </div>
        <div>{{ comp_amount }} <button type="button" class="btn btn-dark float-end" @click="copy2c(3)"><i class="fas fa-clipboard"></i></button> </div>

      <div class="row">zip: </div>
        <div>{{ zipcode }} <button type="button" class="btn btn-dark float-end" @click="copy2c(4)"><i class="fas fa-clipboard"></i></button> </div> -->
    </div>
  </div>
</div>

<script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>

<script src="https://unpkg.com/@popperjs/core@2"></script>
<script src="https://unpkg.com/tippy.js@6"></script>

  <!-- const payment_re = /(?<payment>(?<payment_amount>(\$ *)?\d+(?:.\d+)?\$?) *(?<payment_method>cc|c|cash|credit|debit|credit *card|zelle|cash *app))/gi
  const comp_re = /(?<comp>(?:comp|com *parts|comp|company *parts) *(?<comp_amount>(\$ *)?\d+(?:.\d+)?\$?))/gi
  const zip_re = /(?<!\d|\+|\-|\#)(\d{5})(?!\d|\+|\-|\#)/gi -->
<script type="text/javascript">

  const payment_re = /(?:\$ *)?(?<payment_amount>\d+(?:.\d+)?\$?) *(?<payment_method>cash *app|zelle|credit *card|debit|credit|cash|cc|c)/gi
  const comp_re = /(?:comp|com *parts|comp|company *parts) *(?:\$ *)?(?<comp_amount>\d+(?:.\d+)?)(?: *\$)?/gi
  const zip_re = /(?<!\d|\+|\-|\#)(\d{5})(?!\d|\+|\-|\#)/gi


  var app = new Vue({
  el: '#app',
  data: {
  text: `$ 300 CC Isaac

  comp 10$
  Company: American Services
  Job: K7XGL
  Name: sukh
  Phone1: +12522423332 5982# (Customer Ext. 378)
  Phone2: +12522423332 5770# (Customer Ext. 378)
  Job Type: Car Key Made
  2020 international lt625 white
  Price: N/A
  Address: 4540 Fisher Road
  Columbus, OH 43228
  Job Notes: unlock`,
  payment: '',
  payment_amount: '',
  payment_method: '',
  comp_amount: '',
  zipcode: ''
  },
  created: function () {
      this.diegest()
  },
  methods: {
    diegest: function () {
      payment_re.lastIndex = 0
      comp_re.lastIndex = 0
      zip_re.lastIndex = 0

      temp = payment_re.exec(this.text)
      if (temp) {
        this.payment = temp[0]
        this.payment_amount = temp[1]
        this.payment_method = temp[2]
      } else {
        this.payment = ''
        this.payment_amount = ''
        this.payment_method = ''
      }

      temp = comp_re.exec(this.text)
      this.comp_amount = (temp) ? temp[1] : ''

      temp = this.text.match(zip_re)
      this.zipcode = (temp) ? temp[temp.length-1] : ''
    },
    copy2c: function(event) {
        var dummy = document.createElement("textarea")
        // to avoid breaking orgain page when copying more words
        // cant copy when adding below this code
        // dummy.style.display = 'none'
        document.body.appendChild(dummy)
        //Be careful if you use texarea. setAttribute('value', value), which works with "input" does not work with "textarea". – Eduard
        data_element = event.target.closest("tr").querySelector("#data")
        let text
        text = data_element.innerText
        dummy.value = text
        dummy.select()
        document.execCommand("copy")
        document.body.removeChild(dummy)

        data_element._tippy.show(150)
    }
  }
})


  tippy('#data', {
    content: 'Value copied!',
    placement: 'left',
    trigger: 'manual',
    onShow(instance) {
    setTimeout(() => {
      instance.hide();
    }, 1000);
  }

  })

</script>
